<script lang="ts">
import { onDestroy, onMount } from 'svelte';
import { curRoute } from './store.ts';
import routes from './routes.ts';

let component: any;

// Route upon initialization
onMount(() => {
	curRoute.set(window.location.pathname);

	if (!history.state) {
		window.history.replaceState({path: window.location.pathname}, '', window.location.href);
	}
});
// Update component as route changes
const unsubscribe = curRoute.subscribe((value: string) => {
	component = routes.filter(r => r.path === value)[0].component;
});
// Handle component change on browser back
const handlerBackNavigation = (event: any): void => {
	curRoute.set(event.state.path);
};
// Unsubscribe to current route on destroy to avoid memory leaks
onDestroy(unsubscribe);
</script>

<!-- Attach browser back handler to window -->
<svelte:window on:popstate={handlerBackNavigation} />
<!-- Render component to be loaded -->
<svelte:component this={component} />